> For the complete documentation index, see [llms.txt](https://docs.rallyprotocol.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rallyprotocol.com/unity/gasless-transactions/deploy-a-contract-gaslessly.md).

# Deploy a contract gaslessly

{% hint style="info" %}
An API key is required to use the infrastructure to power gasless transactions. Visit  <https://app.rallyprotocol.com/> to generate both Amoy and Mainnet Polygon API keys.&#x20;
{% endhint %}

## Deploy contracts with the relay method

To gaslessly deploy a contract, create a [GSN transaction object](https://github.com/rally-dfs/rly-network-mobile-sdk/blob/736e1de0859bec5230abba80e978f76f43fe2123/src/gsnClient/utils.ts#L16)  and use the `relay()` method to send the transaction to our relayer.

```csharp
var gsnTx = new GsnTransactionDetails(
  from: accountAddress,
  data: tx.data,
  value: "0",
  to: contractAddress,
  gas: gas.ToString(),
  maxFeePerGas: maxFeePerGas.ToString(),
  maxPriorityFeePerGas: maxPriorityFeePerGas.ToString(),
);

await amoy.Relay(gsnTx)


// relay arbitrary tx through our gasless relayer. see a complete Flutter example at
// https://github.com/rally-dfs/flutter-example-app/tree/main/app/lib/services/nft.dart
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.rallyprotocol.com/unity/gasless-transactions/deploy-a-contract-gaslessly.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
